local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_Worldboss"
local realm = GetRealmName()
local player = UnitName('player').."-"..realm
local maxlevel = 90
local curVersion = 5402
local db
local defaults = {
	['hideRealm'] = true,
	['sameRealm'] = true,
	['expansions'] = {
		['MoP'] = {
			['name'] = "Pandaria",
			['active'] = true,
			['minlevel'] = 87,
			['maxlevel'] = maxlevel,
		},
		['Timeless'] = {
			['name'] = "Timeless Isle",
			['active'] = false,
			['minlevel'] = 90,
			['maxlevel'] = maxlevel,
		}
	},
	['quests'] = {
		[32099] = {
			['active'] = true,
			['name'] = "Sha",
			['minlevel'] = 87,
			['expansion'] = 'MoP',
		},
		[32098] = {
			['active'] = true,
			['name'] = "Galleon",
			['minlevel'] = 87,
			['expansion'] = 'MoP',
		},
		[32518] = {
			['active'] = true,
			['name'] = "Nalak",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},
		[32519] = {
			['active'] = true,
			['name'] = "Oondasta",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},
		[32609] = {
			['active'] = true,
			['name'] = "Chest",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},
		[32626] = {
			['active'] = true,
			['name'] = "Key",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},
		[32719] = {
			['active'] = true,
			['name'] = "Roll",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},[33117] = {
			['active'] = true,
			['name'] = "Celestials",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},[33118] = {
			['active'] = true,
			['name'] = "Ordos",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},[33233] = {
			['active'] = true,
			['name'] = "CTA LFR",
			['minlevel'] = 90,
			['expansion'] = 'MoP',
		},[33170] = {
			['name']="Moss-Covered Chest 16",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=36.70,
			['y']=34.03
		},[33171] = {
			['name']="Moss-Covered Chest 07",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=25.52,
			['y']=27.21,
		},[33172] = {
			['name']="Moss-Covered Chest 10",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=27.36,
			['y']=39.09
		},[33173] = {
			['name']="Moss-Covered Chest 12",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=30.60,
			['y']=36.55
		},[33174] = {
			['name']="Moss-Covered Chest 03",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=22.42,
			['y']=35.35
		},[33175] = {
			['name']="Moss-Covered Chest 01",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=22.20,
			['y']=49.30
		},[33176] = {
			['name']="Moss-Covered Chest 05",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=24.75,
			['y']=53.01
		},[33177] = {
			['name']="Moss-Covered Chest 06",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=25.66,
			['y']=45.84
		},[33178] = {
			['name']="Moss-Covered Chest 02",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=22.24,
			['y']=68.08
		},[33179] = {
			['name']="Moss-Covered Chest 09",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=26.85,
			['y']=68.75
		},[33180] = {
			['name']="Moss-Covered Chest 13",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=31.00,
			['y']=76.33
		},[33181] = {
			['name']="Moss-Covered Chest 15",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=35.36,
			['y']=76.42
		},[33182] = {
			['name']="Moss-Covered Chest 17",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=38.73,
			['y']=71.59
		},[33183] = {
			['name']="Moss-Covered Chest 18",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=39.79,
			['y']=79.53
		},[33184] = {
			['name']="Moss-Covered Chest 14",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=34.85,
			['y']=84.22
		},[33185] = {
			['name']="Moss-Covered Chest 19",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=43.56,
			['y']=84.04
		},[33186] = {
			['name']="Moss-Covered Chest 22",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=46.95,
			['y']=53.69
		},[33187] = {
			['name']="Moss-Covered Chest 21",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=46.76,
			['y']=46.78
		},[33188] = {
			['name']="Moss-Covered Chest 24",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=51.15,
			['y']=45.72
		},[33189] = {
			['name']="Moss-Covered Chest 27",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=55.52,
			['y']=44.34
		},[33190] = {
			['name']="Moss-Covered Chest 28",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=58.01,
			['y']=50.70
		},[33191] = {
			['name']="Moss-Covered Chest 34",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=65.63,
			['y']=47.83
		},[33192] = {
			['name']="Moss-Covered Chest 32",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=63.81,
			['y']=59.15
		},[33193] = {
			['name']="Moss-Covered Chest 33",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=64.91,
			['y']=75.59
		},[33194] = {
			['name']="Moss-Covered Chest 30",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=60.17,
			['y']=66.03
		},[33195] = {
			['name']="Moss-Covered Chest 23",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=49.71,
			['y']=65.72
		},[33196] = {
			['name']="Moss-Covered Chest 26",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=53.09,
			['y']=70.77
		},[33197] = {
			['name']="Moss-Covered Chest 25",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=52.75,
			['y']=62.86
		},[33227] = {
			['name']="Moss-Covered Chest 31",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=61.64,
			['y']=88.49
		},[33198] = {
			['name']="Moss-Covered Chest 20",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=44.13,
			['y']=65.46
		},[33199] = {
			['name']="Moss-Covered Chest 08",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=26.01,
			['y']=61.45
		},[33200] = {
			['name']="Moss-Covered Chest 04",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=24.62,
			['y']=38.63
		},[33202] = {
			['name']="Moss-Covered Chest 11",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=29.68,
			['y']=31.74
		},[33201] = {
			['name']="Moss-Covered Chest 29",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=59.91,
			['y']=31.32
		},[33203] = {
			['name']="Skull-Covered Chest Inside Cavern of Lost Spirits",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=49.71,
			['y']=32.3
		},[33204] = {
			['name']="Sturdy Chest 02 Use Albatross or glider",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=28.19,
			['y']=35.21
		},[33205] = {
			['name']="Sturdy Chest 01 Use Albatross or glider",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=26.67,
			['y']=64.95
		},[33206] = {
			['name']="Sturdy Chest 04",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=64.68,
			['y']=70.47
		},[33207] = {
			['name']="Sturdy Chest 03",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=59.25,
			['y']=49.46
		},[33208] = {
			['name']="Smoldering Chest 02",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=69.57,
			['y']=32.89
		},[33209] = {
			['name']="Smoldering Chest 01",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=53.98,
			['y']=78.05
		},[33210] = {
			['name']="Blazing Chest",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=47.26,
			['y']=26.82
		},[32957] = {
			['name']="Sunken Treasure",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=40.4,
			['y']=92.3
		},[32956] = {
			['name']="Blackguard's Jetsam",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=22.5,
			['y']=58.9
		},[32968] = {
			['name']="Rope-Bound Treasure Chest",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=53.9,
			['y']=47.1
		},[32970] = {
			['name']="Gleaming Treasure Satchel",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=70.7,
			['y']=80.9
		},[32969] = {
			['name']="Gleaming Treasure Chest",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=49.7,
			['y']=69.5
		},[32971] = {
			['name']="Mist-Covered Treasure Chest",
			['expansion'] = 'Timeless',
			['active'] = true,
			['minlevel'] = 90,
			['location'] = 951,
			['x']=58.5,
			['y']=60.9
		}
	},
	['char_db'] = {},
}

local function update()
  if(db['quests']) then
	for questId, questData in pairs(db['quests']) do
--		print(player..":"..questId.." "..tostring(questData['minlevel']) .. "-".. tostring(db['char_db'][player]['level']))
		if(questData['minlevel'] <= db['char_db'][player]['level']) then
			db['char_db'][player][questId] = IsQuestFlaggedCompleted(questId) and true or nil
		end
		if(questData['location']) then
			local pin = addon['getPin'](name.."_quest_"..questId,questData['x'],questData['y'],questData['location'],questData['name'],questData['icon'] or 'Interface\\WorldMap\\TreasureChest_64')
			if(db['char_db'][player][questId]) then
				addon['removePin'](name.."_quest_"..questId)
			end
		end
	end
  end
end

local function onupdate(self,dt)
	self['elapsed'] = (self['elapsed'] or 0) - dt
	if(self['elapsed'] < 0) then
		self['elapsed'] = 5
		update()

	end
end
local function event(self,evnt,...)
	if(evnt == "PLAYER_REGEN_DISABLED") then
		self:SetScript("OnUpdate", nil)
	elseif(evnt == "PLAYER_REGEN_ENABLED") then
		self:SetScript("OnUpdate", onupdate)
	else
		update()
	end
end
local function reset()
	for k,v in pairs(db['char_db']) do
		for a,b in pairs(v) do
			if(a ~= 'level') then
				v[a] = nil
			end
		end
	end
	update()
end
local function OnTooltip()
	GameTooltip:ClearLines()
	if(db['expansions']) then
		for expansion, info in pairs(db['expansions']) do
			if(info['active']) then
				GameTooltip:AddLine(info['name'])
				for charName, charData in pairs(db['char_db']) do
					local cn,cr = strsplit("-",charName,2)
					local cdn = db['hideRealm'] and cn or charName
					if(charData['level'] >= info['minlevel']) then
						line = ""
						for questId, questData in pairs(db['quests']) do
							if(questData['expansion'] == expansion and charData['level'] >= questData['minlevel']) then
								if(questData['active']) then
									if( line ~= "") then
										line = line .. "/"
									end
									line = line .. addon['colorize'](questData['name'], charData[questId] and '00ff00' or 'ff0000')
								end
							end
						end
						if(line ~= "" and (((db['sameRealm'] and cr == realm) and true or false) or not db['sameRealm'])) then
							GameTooltip:AddDoubleLine(cdn,line)
						end
					end
				end
			end
		end
	end
end
local function setQuestPref(info,value)
	local val, quest = strsplit("_",info[#info],2)
	if(tostring(val) == 'quest') then
		return
	elseif(tostring(val) == 'minlevel') then
		db['quests'][tonumber(quest)][tostring(val)] = tonumber(value)
	else
		db['quests'][tonumber(quest)][tostring(val)] = value
	end
	addon['updatePrefs']()
end
local function getQuestPref(info)
	local val, quest = strsplit("_",info[#info],2)
	if(tostring(val) == 'quest') then
		return tostring(quest)
	elseif(tostring(val) == 'minlevel') then
		if(db['quests'] and db['quests'][tonumber(quest)]) then
			return tostring(db['quests'][tonumber(quest)][tostring(val)])
		else
			return nil
		end
	end
	if(db['quests'] and db['quests'][tonumber(quest)]) then
		return db['quests'] and db['quests'][tonumber(quest)][tostring(val)] or nil
	end
end
local function getExpansionPref(info)
	local val, expansion = strsplit("_",info[#info],2)
	if(val=='add') then
		return ""
	elseif(expansion and db['expansions']) then
		if((val == 'minlevel') or (val == 'maxlevel')) then
			return tostring(db['expansions'][expansion][val])
		else
			return db['expansions'][expansion][val]
		end
	end
end
local function setExpansionPref(info,value)
	local val, expansion = strsplit("_",info[#info],2)
	if(val == 'add') then
		local q = tonumber(value)
		if(q  and q > 0 and not db['quests'][q]) then
			db['quests'][q] = {
				['active'] = true,
				['name'] = "Quest "..tostring(q),
				['minlevel'] = maxlevel,
				['expansion'] = expansion,
			}
		end
	else
		if((val == 'minlevel') or (val == 'maxlevel')) then
			db['expansions'][expansion][val] = tonumber(value)
		else
			db['expansions'][expansion][val] = value
		end
	end
	addon['updatePrefs']()
end
local function removeQuest(info)
	local _, quest = strsplit("_",info[#info],2)
	if(tonumber(quest) > 0 and db['quests'][tonumber(quest)]) then
		db['quests'][tonumber(quest)] = nil
		addon['updatePrefs']()
	end
end
local function removeExpansion(info)
	local _, expansion = strsplit("_",info[#info],2)
	if(tostring(expansion) and db['expansions'][tostring(expansion)]) then
		db['expansions'][tostring(expansion)] = nil
		for quest,qTab in pairs(db['quests']) do
			if(qTab['expansion'] == expansion) then
				db['quests'][tonumber(quest)] = nil
			end
		end
		addon['updatePrefs']()
	end
end
local function restoreDefaults()
	addon['db']['profile'][childName] = CopyTable(defaults)
	db = addon['db']['profile'][childName]
	db['char_db'][player] = db['char_db'][player] or {}
	db['char_db'][player]['level'] = UnitLevel('player')
	addon['updatePrefs']()
end
addon['updatePrefs'] = function()
	local p = addon['options']['args']['Expansions']
	wipe(p['args'])
	addon['AddConfigEntry'](addon,childName,'input','add',"Add Expansion","",1,nil,nil,nil,nil,p)
	for expansion, tab in pairs(db['expansions']) do
		local menu = addon['AddConfigMenu'](addon,{
			['name'] = expansion,
			['order'] = 2,
			['childGroups'] = 'tree',
			['args'] = {},
			['menuGet'] = getExpansionPref,
			['menuSet'] = setExpansionPref,
		}, p)
		addon['AddConfigEntry'](addon,childName,'toggle','active_'..expansion,"Active","",1,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','name_'..expansion,"Name","Display Name of the expansion",2,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','minlevel_'..expansion,"Min Level","Minimum level to complete the quest",3,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','maxlevel_'..expansion,"Max Level","Maximum level to display the quest",4,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'header','head1',"Add Quest","",5,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','add_'..expansion,"Add Id","Add QuestId - Keep in mind that some quests are factionspecific.",6,nil,nil,nil,nil,menu)
		for quest, qTab in pairs(db['quests']) do
			if(qTab['expansion'] == expansion) then
				local submenu = addon['AddConfigMenu'](addon,{
					['name'] = addon['colorize'](qTab['name'],(qTab['active'] and "ffffff" or "ff0000")),
					['order'] = 7,
					['childGroups'] = 'tree',
					['args'] = {},
					['menuGet'] = getQuestPref,
					['menuSet'] = setQuestPref,
				}, menu)
				addon['AddConfigEntry'](addon,childName,'toggle','active_'..quest,"Active","",1,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'input','quest_'..quest,"QuestId","",2,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'input','name_'..quest,"Questname","",3,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'input','minlevel_'..quest,"Quest Minlevel","Minimum level to accept the quest",4,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'execute','deleteQuest_'..quest,"Remove","Remove quest",5,removeQuest,nil,nil,nil,submenu)
			end
		end
		addon['AddConfigEntry'](addon,childName,'header','head2',"Remove Expansion","",8,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'execute','delete_'..expansion,"Remove","Remove expansion and all quests",9,removeExpansion,nil,nil,nil,menu)
	end
	addon['AddConfigEntry'](addon,childName,'execute','restore',"Restore","Undo all changes and restore default expansions and quests",3,restoreDefaults,nil,nil,nil,p)
	update()
end
local function getPref(info)
	return addon['db']['profile'][childName][info[#info]]
end
local function setPref(info,value)
	if(info[#info]=='add') then
		if(not db['expansions'][tostring(value)]) then
			db['expansions'][tostring(value)] = {
				['name'] = "NA",
				['active'] = true,
				['minlevel'] = maxlevel,
				['maxlevel'] = maxlevel,
			}
		end
	else
		addon['db']['profile'][childName][info[#info]] = value
	end
	addon['updatePrefs']()
end
local function addNew()
	local steps = {
		[5401] = {
			['quests'] = {33117,33118,33233},
		},
		[5402] = {
			['quests'] = {33170,33171,33172,33173,33174,33175,33176,33177,33178,33179,33180,33181,33182,33183,33184,33185,33186,33187,33188,33189,33190,33191,33192,33193,33194,33195,33196,33197,33227,33198,33199,33200,33202,33201,33203,33204,33205,33206,33207,33208,33209,33210,32957,32956,32968,32970,32969,32971},
		}
	}
	for a,b in pairs(steps) do
		if(a > db['version']) then
			db['quests'] = db['quests'] or {}
			for _,quest in pairs(b['quests']) do
				db['quests'][tonumber(quest)] = CopyTable(defaults['quests'][tonumber(quest)])
			end
		end
	end
	db['version'] = curVersion
end
local function init()
	addon['options'] = addon['InitConfig'](addon, childName, true, {
		['name'] = childName,
		['type'] = "launcher",
		['icon'] = "Interface\\Icons\\ability_monk_roll",
		['OnTooltipShow'] = OnTooltip,
	}, getPref,setPref)
	db = addon['db']['profile'][childName]
	if(db['sha']) then
		restoreDefaults()
	end
	db['version'] = db['version'] or 0
	if(db['version'] < curVersion) then
		addNew()
	end
	db['char_db'][player] = db['char_db'][player] or {}
	db['char_db'][player]['level'] = UnitLevel('player')
	addon['AddConfigMenu'](addon,{
		['name'] = "Expansions",
		['order'] = 2,
		['childGroups'] = 'tab',
		['menuGet'] = getPref,
		['menuSet'] = setPref,
		['args'] = {},
	}, addon['options'])
	addon['AddConfigEntry'](addon,childName,'toggle','hideRealm',"Hide Realm","Don't display realm in tooltip",1)
	addon['AddConfigEntry'](addon,childName,'toggle','sameRealm',"Same Realm only","Don't display other realms",2)
	addon['AddConfigEntry'](addon,childName,'execute','resetData',"Reset","Reset stored quest status",3,reset)
	addon['updatePrefs']()
	addon['RegisterFunc']({"QUEST_LOG_UPDATE","PLAYER_LOGOUT","PLAYER_REGEN_DISABLED","PLAYER_REGEN_ENABLED"},"OnEvent", event)
end
addon['startup'](addon, name, childName, init, true, defaults)
